#if defined(WIN32)
#  include "glut.h"
#  include "glext.h"
extern PFNGLMULTITEXCOORD2DVPROC glMultiTexCoord2dv;
extern PFNGLMULTITEXCOORD3DPROC glMultiTexCoord3d;
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

#include "rectangle.h"
#include "matrix.h"

/*
** `̕`
*/
void rectangle(double w, double h, const float l[])
{
  /* _̍Wl */
  const GLdouble vertex[4][3] = {
    { -w, -h, 0.0 },
    {  w, -h, 0.0 },
    {  w,  h, 0.0 },
    { -w,  h, 0.0 }
  };
  
  /* _̃eNX`W */
  static const GLdouble texcoord[4][2] = {
    { 0.0, 0.0 }, { 1.0, 0.0 }, { 1.0, 1.0 }, { 0.0, 1.0 }
  };
  
  /* xNg̎Zoɗpϐ */
  double m[16], lpos[4] = { l[0], l[1], l[2], l[3] };
  
  /* ݂̃fr[ϊs߂ */
  glGetDoublev(GL_MODELVIEW_MATRIX, m);
  
  /* ڋԂɂʒu߂ */
  inverse(m, m);
  transform(lpos, m, lpos);
  
  /* słȂΎW߂Ă */
  if (lpos[3] != 0.0) {
    lpos[0] /= lpos[3];
    lpos[1] /= lpos[3];
    lpos[2] /= lpos[3];
  }
  
  /* `` */
  glBegin(GL_QUADS);
  
  for (int i = 0; i < 4; ++i) {
    /* @}bṽeNX`Wݒ肷 */
    glTexCoord2dv(texcoord[i]);
    glMultiTexCoord2dv(GL_TEXTURE2, texcoord[i]);
    
    /* ڋԂɂ̕xNg
       K}bṽeNX`Wɐݒ肷 */
    if (lpos[3] != 0.0) {
      glMultiTexCoord3d(GL_TEXTURE1,
        lpos[0] - vertex[i][0],
        lpos[1] - vertex[i][1],
        lpos[2] - vertex[i][2]);
    }
    else {
      glMultiTexCoord3d(GL_TEXTURE1, lpos[0], lpos[1], lpos[2]);
    }
    
    /* Ή钸_W̎w */
    glVertex3dv(vertex[i]);
  }
  glEnd();
}
